package graph;

import java.io.*;
import java.util.*;

class Edge implements Comparable<Edge> {
    int from, to, weight, pos;

    Edge(int from, int to, int weight, int pos) {
        this.from = from;
        this.to =to;
        this.weight = weight;
        this.pos = pos;
    }

    @Override
    public int compareTo(Edge o) {
        Edge e1 = (Edge)o;
        if(e1.weight ==this.weight)
            return 0;
        return e1.weight < this.weight ? 1 : -1;
    }

    @Override
    public String toString() {
        return String.format("From:%d \t To:%d \t Weight:%d\n", from, to, weight);

    }
}

public class graph {  
    
    public static void main(String args[]) {
        try {
            FileReader file = new FileReader("graph.in");
            BufferedReader buff = new BufferedReader(file);
            String line = buff.readLine();
            StringTokenizer info = new StringTokenizer(line, " ");
            int nv = Integer.valueOf(info.nextToken());
            int ne = Integer.valueOf(info.nextToken());
            ArrayList<Edge> edges = new ArrayList<>();
            ArrayList<Integer> vertices = new ArrayList<>();
          
            for (int i = 1; i <= ne; i++) {
                line = buff.readLine();
                StringTokenizer tok = new StringTokenizer(line, " ");
                int from = Integer.valueOf(tok.nextToken());
                int to = Integer.valueOf(tok.nextToken());
                int weight = Integer.valueOf(tok.nextToken());
                edges.add(new Edge(from, to, weight, i));
            }

            for (Edge e : edges) {
                if (!vertices.contains(e.from)) {
                    vertices.add(e.from);

                }

                if (!vertices.contains(e.to)) {
                    vertices.add(e.to);

                }
            }

            HashMap<Integer, Set<Integer>> forest = new HashMap<Integer, Set<Integer>>();
            for(Integer vertex : vertices) {
                Set<Integer> vs = new HashSet<Integer>();
                vs.add(vertex);
                forest.put(vertex, vs);
            }

            Collections.sort(edges);
            ArrayList<Edge> minSpanTree = new ArrayList<Edge>();
            while (true) {
                Edge check = edges.remove(0);

                Set<Integer> visited1 = forest.get(check.from);
                Set<Integer> visited2 = forest.get(check.to);
                if(visited1.equals(visited2))
                    continue;

                minSpanTree.add(check);
                visited1.addAll(visited2);

                for(Integer i : visited1) {
                    forest.put(i, visited1);
                }

                if(visited1.size() == vertices.size())
                    break;
            }

            System.out.print(minSpanTree);
            printMST(minSpanTree);
        } catch(IOException e){
            System.out.println("Can't find the file");
        }
    }

    private static void printMST(ArrayList<Edge> minSpanTree) {
        try {
            PrintStream fileWriter = new PrintStream("graph.out", "windows-1251");
            for (Edge e : minSpanTree) {
                fileWriter.println(e.pos);
            }
            fileWriter.close();
        } catch (FileNotFoundException | UnsupportedEncodingException ex) {
            //System.out.println("File not found!");
        }
    }
}
